//-------------------
// Benchmark Othello
// version WIN32 et POCKETPC
// Sylvain Huet
// Premiere version : 24/08/2002
// Derniere mise a jour : 26/08/2002

#include <stdio.h>
#include <string.h>
#include "types.h"
#include "alpha.h"
#include "eval.h"


int depla[]={-11,-10,-9,-1,1,9,10,11};
int pos[]={
	88,81,11,18,33,36,63,66,43,64,
	46,65,34,35,56,53,32,42,52,62,
	23,24,25,26,37,47,57,67,73,74,
	75,76,31,13,38,83,41,51,61,14,
	15,16,48,58,68,84,85,86,21,71,
	12,17,28,78,82,87,22,77,27,72,
	-1,-1,-1,-1
};



/* retourne 1 si eval est assure */
int faitb(char *tab,int max,int color,int prof,int couleur
		  ,int eva, int num,int *mcoup)
{
	char tab2[100];
	int d,i,dep,j;
	int c,flag,flag2,ret;
    
	prof++;
	flag2=0;
	while(num<60)
    {
		c=pos[num];
		if (tab[c]==0)
		{
			flag=0;
			for (i=0;i<8;i++)
			{
				dep = depla[i];
				d=c+dep;
				if (tab[d]== -color)
				{
					do
					{
						d+=dep;
					}
					while(tab[d]== -color);
					if (tab[d]==color)
					{
						
						if (flag==0)
							memcpy(tab2,tab,sizeof(char)*100);
						flag=1;
						flag2=1;
						for (j=c;j!=d;j+=dep) tab2[j]=color;
					}
				}
			}
			if (flag==1)
			{
				if (prof==0) *mcoup=num;
				if (prof<max) 
					ret=faitb(tab2,max,-color,prof,couleur,eva,0,mcoup);
				else 
				{
					ret=eval(tab2,couleur);
					if (ret>=eva) ret=1; else ret=0;
				}
				
				if ((prof%2==0)&&(ret==1)) return 1;
				if ((prof%2==1)&&(ret==0)) return 0;
				
			}
		}
		num++;
    }
	if (flag2==1)
    {
		if (prof%2==0) return 0;
		else return 1;
    }
	else
    {
		if (prof==0) *mcoup=-1;
		if (prof<max) 
			ret=faitb(tab,max,-color,prof,couleur,eva,0,mcoup);
		else 
		{
			ret=eval(tab,couleur);
			if (ret>=eva) ret=1; else ret=0;
		}
		return(ret);
    }
}


int icib(char *tab,int max,int couleur)
{
	int res,eva,dicho,coup;
	int flagavantdicho,sens;
	int mcoup;
	
	compteur=0;
	
	eva=0;
	dicho=64;
	coup=0;

	flagavantdicho=1;
	sens=-1;

	while(dicho>=0)
    { 
//		printf("eva      : %d max=%d couleur=%d coup=%d\n",eva,max,couleur,coup);

		mcoup=0;
		res=faitb(tab,max,couleur,-1,couleur,eva,coup,&mcoup);
		if (flagavantdicho)
		{
			if (sens==-1) sens=res;
			if (sens!=res)
			{
				flagavantdicho=0;
				dicho>>=1;
			}
		}
		if (res)
		{
			eva+=dicho;
			coup=mcoup;
		}
		else eva-=dicho;
		if (!flagavantdicho)
		  {
			if (dicho>0) dicho>>=1;
			else dicho=-1;
		  }
    }
	if (!res) eva--;
	
	if (coup!=-1) coup=pos[coup];
	printf("resultat : eval=%d coup=%d n=%ld\n",eva,coup,compteur);
	
	return(coup);
}

int valid(char *tab,int coup,int color,int oui)
{
	int flag=0;
	int i,buf,buf2;
	if (tab[coup]!=0) return(0);
	for (i=0;i<8;i++)
    {
		buf=coup;
		while (tab[buf+=depla[i]]==-color);
		if ((buf!=coup+depla[i])&&(tab[buf]==color))
		{
			flag=1;
			if (oui!=0) // jouer reellement le coup
				for (buf2=coup;buf2!=buf;buf2+=depla[i])
					tab[buf2]= color;
		}
    }
	return(flag);
}

int doitpasser(char *tab,int color)
{
	int i,j;

	for (i=10;i<90;i+=10)
		for(j=i+1;j<i+9;j++)
			if (valid(tab,j,color,0)) return 0;
	return 1;
}
